# Copyright (c) 2004-2006 Bethel University. All rights reserved.
# See also gpl.txt
# Zope
import zLOG
import install
from Products.Silva.ExtensionRegistry import extensionRegistry
from Products.Silva.fssite import registerDirectory
from Products.SilvaMetadata.Compatibility import registerTypeForMetadata

from Products.Silva.ImporterRegistry import importer_registry

from Products.SilvaCustomAutoTOC.silvaxml import xmlexport, xmlimport

import CustomAutoTOC

def initialize(context):
    extensionRegistry.register(
        'SilvaCustomAutoTOC', 'Silva Custom AutoTOC', context,
        [CustomAutoTOC],
        install, depends_on='Silva')

    # register the FileSystemSite directories
    registerDirectory('views', globals())

    registerTypeForMetadata(CustomAutoTOC.CustomAutoTOC.meta_type)
    # register xml import functions (old style XML importer)	 
    # we let the xml import functionality of Publication handle any 	 
    # root elements, since a Silva instance can not import another root
    #importer_registry.register_tag('silva_root', 	 
    #                               Publication.xml_import_handler)
    

    # old XML importer
    importer_registry.register_tag('silva_custom_auto_toc', 	 
                                   CustomAutoTOC.xml_import_handler)

    #------------------------------
    # Initialize the XML registries
    #------------------------------
    
    xmlexport.initializeXMLExportRegistry()
    xmlimport.initializeXMLImportRegistry()

    import upgrade_15
    upgrade_15.initialize()
