# Copyright (c) 2004-2006 Bethel University. All rights reserved.
# See also gpl.txt
from Products.Silva.silvaxml.xmlimport import theXMLImporter, SilvaBaseHandler, generateUniqueId
from Products.Silva import mangle

ProductNS = 'http://zope.org/Members/aaltepet/ns/silva_custom_auto_toc'

def initializeXMLImportRegistry():
    """Initialize the global importer object.
    """
    importer = theXMLImporter
    importer.registerHandler((ProductNS, 'custom_auto_toc'), CustomAutoTOCHandler)

class CustomAutoTOCHandler(SilvaBaseHandler):
    def startElementNS(self, name, qname, attrs):
        if name == (ProductNS, 'custom_auto_toc'):
            id = str(attrs[(None, 'id')])
            uid = generateUniqueId(id, self.parent())
            self.parent().manage_addProduct['SilvaCustomAutoTOC'].manage_addCustomAutoTOC(uid, '')
            obj = getattr(self.parent(), uid)
            obj.set_depth(int(attrs[(None, 'depth')]))
            obj.set_local_types(attrs[(None, 'types')].split(','))
            #also want to set local_types and depth
            self.setResult(obj)
    def endElementNS(self, name, qname):
        if name == (ProductNS, 'custom_auto_toc'):
            self.setMaintitle()
            self.storeMetadata()
